// Projector.cpp :  DLL ĳʼ̡
//

#include "stdafx.h"
#include "Projector.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

//
//TODO:   DLL  MFC DLL Ƕ̬ӵģ
//		Ӵ DLL κε
//		MFC ĺ뽫 AFX_MANAGE_STATE ӵ
//		úǰ档
//
//		: 
//
//		extern "C" BOOL PASCAL EXPORT ExportedFunction()
//		{
//			AFX_MANAGE_STATE(AfxGetStaticModuleState());
//			// ˴Ϊͨ
//		}
//
//		˺κ MFC 
//		ÿʮҪ  ζ
//		Ϊеĵһ
//		֣ж
//		ΪǵĹ캯 MFC
//		DLL á
//
//		йϸϢ
//		 MFC ˵ 33  58
//

// CProjectorApp

BEGIN_MESSAGE_MAP(CProjectorApp, CWinApp)
END_MESSAGE_MAP()


// CProjectorApp 

CProjectorApp::CProjectorApp()
{
	// TODO:  ڴ˴ӹ룬
	// Ҫĳʼ InitInstance 
}


// Ψһһ CProjectorApp 

CProjectorApp theApp;


// CProjectorApp ʼ

BOOL CProjectorApp::InitInstance()
{
	CWinApp::InitInstance();

	return TRUE;
}


#define CMD_POWER_ON		0xFA
#define CMD_POWER_DOWN		0xFB
#define CMD_SET_LED_ON		0x4B
#define CMD_SET_LED_OFF		0x47
#define CMD_GET_LED_STATUS	0x53
#define CMD_SAVE_CURRENT	0xFC
#define CMD_REFRASH_HDMI	0xF9
#define CMD_GET_LED_TEMP	0x4E
#define CMD_GET_WORK_TIME	0x4F
#define CMD_RESET_LED_TIME	0xFE
#define CMD_GET_SW_VERSION	0xF5
#define CMD_SET_CURRENT		0x54

#define CMD_FAN_ERR_DETECT	0xF7
#define CMD_TEMP_ERR_DETECT	0xF6

#define PAKAGE_BUF_SIZE		(0x400)
#define RCV_DATA_RETRY_TIME (100)
#define INTERVAL_SLEEP_TIME (10)

#define STATUS_OK			0


struct data_pkg {
	unsigned char buf[PAKAGE_BUF_SIZE];
	int len;
};

CProjector::CProjector(void)
{
}

CProjector::~CProjector(void)
{

}

bool CProjector::OpenCOM(int port)
{
	bool ret = false;
	ret = mSerialPort.InitPort(port);
	if (ret) {
		//mSerialPort.OpenListenThread();
	}
	return ret;
}


bool CProjector::CloseCOM()
{
	//mSerialPort.CloseListenTread();
	mSerialPort.ClosePort();
	return true;
}

bool CheckSum(unsigned char *p, int len)
{
	unsigned char cksum = 0;		/* checksum */

	if (p == NULL)
		return false;

	while (len--) cksum += *p++;	/* calculate checksum */

	if (cksum)
		return false;
	return true;
}

void CheckSumGen(unsigned char *p, int len)
{
	unsigned char checksum = 0;		/* checksum */

	if (p == NULL)
		return;

	while (len--) checksum += *p++;	/* calculate checksum */

	*p = (~checksum);				/* write checksum */
}

bool CheckCmdResult(unsigned char cmd, unsigned char *buf, int len)
{
	bool ret = false;
	if (len <= 3)
		return false;
	if (buf[0] == 0x2A && buf[len - 1] == 0x0D) {
		ret = true;
	}
	if (cmd == CMD_GET_SW_VERSION) {
		return !ret;
	}
	// check cmd
	switch (cmd) {
	case CMD_GET_LED_TEMP:
		if (len < 4)
			ret = false;
		else
			ret &= (buf[len - 2] == 0xFF) ? false : true;
		break;
	case CMD_GET_WORK_TIME:
		ret = (ret && buf[1] == cmd && len == 5);
		break;
	default:
		ret &= (len > 3 && buf[len - 2] == 0x0) ? true : false;
		break;
	}
	if (ret && cmd != buf[1]) {
		if (cmd == CMD_GET_LED_STATUS) {
			ret = (buf[1] == CMD_SET_LED_ON || buf[1] == CMD_SET_LED_OFF) ? true : false;
		}
		else {
			ret = false;
		}
	}

	return ret;
}

bool CProjector::SendCmd(unsigned char cmd, struct data_pkg *send_data, struct data_pkg *rcv_pkg)
{
	unsigned char write_buf[PAKAGE_BUF_SIZE], read_buf[PAKAGE_BUF_SIZE];
	int len = 0;

	if (cmd == CMD_SET_CURRENT) {
		write_buf[len++] = 0x55;
		write_buf[len++] = 0x07;
		write_buf[len++] = 0x54;
		if (send_data != NULL) {
			for (int i = 0; i < send_data->len; i++)
				write_buf[len++] = send_data->buf[i];
			unsigned char *pdata = &write_buf[0];
			CheckSumGen(pdata, len); // add checksum(1 byte)
			len++;
			//printf("len: %d\n", len);
		}
	}
	else {
		write_buf[len++] = 0x2A;
		write_buf[len++] = cmd;
		//if (send_data != NULL) {
		//	for (int i = 0; i < send_data->len; i++)
		//		write_buf[len++] = send_data->buf[i];
		//}
		write_buf[len++] = 0x0D;
	}
#ifdef DUMMY_RESPOSE
	char str[33] = "relese date:20181012_FG";;
	switch (cmd) {
	case CMD_GET_LED_TEMP:
		write_buf[len - 1] = 0x30;
		write_buf[len++] = 0x0D;
		break;
	case CMD_GET_LED_STATUS:
		write_buf[len - 2] = CMD_SET_LED_ON;
		write_buf[len - 1] = 0x00;
		write_buf[len++] = 0x0D;
		break;
	case CMD_GET_WORK_TIME:
		write_buf[len - 1] = 0xff;
		write_buf[len++] = 0x1;
		write_buf[len++] = 0x0D;
		break;
	case CMD_GET_SW_VERSION:
		len = 33;
		strcpy_s((char *)write_buf, len, str);
		len = 25;
		break;
	default:
		write_buf[2] = 0x00;
		write_buf[3] = 0x0D;
		len = 4;
		break;
	}
#endif
	EmptyComBuffer();
	bool ret = mSerialPort.WriteData(write_buf, len);
	//len = 0;
	if (ret) {
		len = GetCmdResult(cmd, read_buf);
		//printf("len: %d\n", len);
		if (len > 0) {
			ret = CheckCmdResult(cmd, read_buf, len);
			if (!ret && len >= 8) {
				// multi cmd
				ret = CheckCmdResult(cmd, read_buf + 4, len - 4);
			}
		}
		else {
			ret = false;
		}
	}
	if (ret && rcv_pkg != NULL) {
		if (ret) {
			memcpy(rcv_pkg->buf, read_buf, len);
			rcv_pkg->len = len;
		}
		else {
			memset(rcv_pkg, 0, sizeof(struct data_pkg));
		}
	}
	//printf("rcv_pkg->len: %d\n", rcv_pkg->len);

	return ret;
}

void CProjector::EmptyComBuffer()
{
	UINT BytesInQue = mSerialPort.GetBytesInCOM();
	if (BytesInQue > 0) {
		unsigned char *buf = new unsigned char[BytesInQue];
		mSerialPort.ReadData(buf, BytesInQue);
		printf("INFO: Drop %d bytes:\n", BytesInQue);
		for (UINT i = 0; i < BytesInQue; i++)
			printf((i == 0) ? "%02X" : "-%02X", buf[i]);
		printf("\n");
		delete buf;
	}
}

int CProjector::GetCmdResult(unsigned char cmd, unsigned char *buf)
{
	int retries = 0;
	UINT lenOfBuffer = ((cmd == CMD_GET_SW_VERSION) ? 18 : 4);
	bool ret = false;
	UINT BytesInQue = 0;

	Sleep(500);
	while (retries < RCV_DATA_RETRY_TIME)
	{
		BytesInQue = mSerialPort.GetBytesInCOM();
		//printf("BytesInQue: %d\n", BytesInQue);
		/** 뻺,Ϣһٲѯ */
		if (BytesInQue < lenOfBuffer) {
			retries++;
			Sleep(INTERVAL_SLEEP_TIME);
			continue;
		}
		else if (BytesInQue > PAKAGE_BUF_SIZE) {
			BytesInQue = PAKAGE_BUF_SIZE;
			printf("WARN: BytesInQue out of range: %d\n", BytesInQue);
		}

		/** ȡ뻺еݲʾ */
		ret = mSerialPort.ReadData(buf, BytesInQue);
		if (ret) {
			break;
		}
	}
	if (retries > 1)
		printf("INFO: retry %d times, BytesInQue: %d\n", retries, BytesInQue);
	return (ret ? BytesInQue : 0);
}

bool CProjector::PowerOn()
{
	return SendCmd(CMD_POWER_ON, NULL, NULL);
}


bool CProjector::PowerDown()
{
	return SendCmd(CMD_POWER_DOWN, NULL, NULL);
}


bool CProjector::OpenLed()
{
	return SendCmd(CMD_SET_LED_ON, NULL, NULL);
}


bool CProjector::CloseLed()
{
	return SendCmd(CMD_SET_LED_OFF, NULL, NULL);
}


bool CProjector::GetLedStatus(bool *status)
{
	struct data_pkg rcv_buf;
	*status = false;
	bool ret = SendCmd(CMD_GET_LED_STATUS, NULL, &rcv_buf);
	if (ret && status) {
		if (rcv_buf.buf[1] == CMD_SET_LED_ON) {
			*status = true;
		}
		else if (rcv_buf.buf[1] == CMD_SET_LED_OFF) {
			*status = false;
		}
	}
	return ret;
}


bool CProjector::SaveCurrent()
{
	return SendCmd(CMD_SAVE_CURRENT, NULL, NULL);
}


bool CProjector::RefreshHdmiSignal()
{
	return SendCmd(CMD_REFRASH_HDMI, NULL, NULL);
}


bool CProjector::SetCurrent(unsigned short r, unsigned short g, unsigned short b)
{
	struct data_pkg data;
	int len = 0;
	data.buf[len++] = r & 0xFF;
	data.buf[len++] = (r >> 8) & 0xFF;
	data.buf[len++] = g & 0xFF;
	data.buf[len++] = (g >> 8) & 0xFF;
	data.buf[len++] = b & 0xFF;
	data.buf[len++] = (b >> 8) & 0xFF;
	data.len = len;
	//printf("len:%d\n", len);
	// checksum
	return SendCmd(CMD_SET_CURRENT, &data, NULL);
}


bool CProjector::GetLedTemperature(short *T)
{
	struct data_pkg rcv_buf;
	bool ret = SendCmd(CMD_GET_LED_TEMP, NULL, &rcv_buf);
	if (T)
		*T = ret ? rcv_buf.buf[2] : 0;

	return ret;
}


bool CProjector::GetWorktime(short *time)
{
	struct data_pkg rcv_buf;
	bool ret = SendCmd(CMD_GET_WORK_TIME, NULL, &rcv_buf);
	if (time)
		*time = ret ? (rcv_buf.buf[2] | (rcv_buf.buf[3] << 8)) : 0;

	return ret;
}


bool CProjector::ResetWorktime()
{
	return SendCmd(CMD_RESET_LED_TIME, NULL, NULL);
}


bool CProjector::GetSWVersion(char *version)
{
	struct data_pkg rcv_buf;
	bool ret = SendCmd(CMD_GET_SW_VERSION, NULL, &rcv_buf);
	if (version) {
		int len = (rcv_buf.len > STRING_LENGTH_MAX) ? STRING_LENGTH_MAX : rcv_buf.len;
		//printf("len: %d\n", len);
		if (ret) {
			memcpy(version, rcv_buf.buf, len);
			version[len] = '\0';
		}
		else {
			memcpy(version, "TIMEOUT!", 9);
		}
	}

	return ret;
}
