#ifndef __IPROJECTOR_H__
#define __IPROJECTOR_H__

#include "stdafx.h"


interface IProjector
{
	virtual bool OpenCOM(int port) = 0;
	virtual bool CloseCOM() = 0;
	virtual bool PowerOn() = 0;
	virtual bool PowerDown() = 0;
	virtual bool OpenLed() = 0;
	virtual bool CloseLed() = 0;
	virtual bool GetLedStatus(bool *status) = 0;
	virtual bool SaveCurrent() = 0;
	virtual bool RefreshHdmiSignal() = 0;
	virtual bool SetCurrent(unsigned short r, unsigned short g, unsigned short b) = 0;
	virtual bool GetLedTemperature(short *T) = 0;
	virtual bool GetWorktime(short *time) = 0;
	virtual bool ResetWorktime() = 0;
	virtual bool GetSWVersion(char *version) = 0;
	virtual ~IProjector(){};
};


#endif